/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GetEventTime.c /main/7 1995/07/14 11:29:59 drk $"
#endif
#endif
/***********************************************************************
  	@(#)GetEventTime.c	1.3.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/29/90 SJS add to sccs
	Calls:

	Summary:
            Extract the time field from the X event
           
        INPUTS:
            event         - the pointer to the X event structure
        
        OUTPUTS:
            none

        RETURNS:
            The X Time found in the event data structure if it exists. 
            If it doesn't exist, it returns zero.
************************************************************************/

#include "xislib.h"

Time xisGetEventTime(event)
XEvent *event;
{
    Time time;

    switch (event->type) {
      case MotionNotify:
          time = event->xmotion.time;
          break;
      case ButtonPress:
      case ButtonRelease:
          time = event->xbutton.time;
          break;
      case KeyPress:
      case KeyRelease:
          time = event->xkey.time;
          break;
      case EnterNotify:
      case LeaveNotify:
          time = event->xcrossing.time;
          break;
      case PropertyNotify:
          time = event->xproperty.time;
          break;
      default:
          time = 0;
          break;
    }

    return time;

} /* End xisGetEventTime() */
