/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: IsMapped.c /main/7 1995/07/14 11:36:20 drk $"
#endif
#endif
/***********************************************************************
  	@(#)IsMapped.c	1.8.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
            06/27/90 PSN add new function xisIsWidgetMapped()
            08/17/90 PSN add new function xisIsViewable()
	Calls:

	Summary:
            Determines if the specified window is mapped or not.

        INPUTS:
            window - window which may be mapped or not
        
        OUTPUTS:
            none

        RETURNS:
            True if window is mapped
            False otherwise
************************************************************************/
#include "xislib.h"

int xisIsMapped(window)
Window window;
{
    static char routine_name[] = "xisIsMapped()";
    XWindowAttributes wattr;

    xisUseSessionInfo(routine_name);

    XGetWindowAttributes(xisDisplay,window,&wattr);

    return(wattr.map_state != IsUnmapped); 

} /* End xisIsMapped() */


int xisIsViewable(window)
Window window;
{
    static char routine_name[] = "xisIsViewable()";
    XWindowAttributes wattr;

    xisUseSessionInfo(routine_name);

    XGetWindowAttributes(xisDisplay,window,&wattr);

    return(wattr.map_state == IsViewable); 

} /* End xisIsViewable() */


/*
 * Return status of widget being mapped or unmapped
 */
int xisIsWidgetMapped(widget)
Widget	widget;
{
    XisObjectRecord	*object = xisGetObjectFromWidget(widget);

    return (xisIsMapped(object->id.window));

} /* End xisIsWidgetMapped() */
