/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: IsSelected.c /main/7 1995/07/14 11:40:17 drk $"
#endif
#endif
/***********************************************************************
  	@(#)IsSelected.c	1.4.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/30/90 SJS add to sccs
	Calls:

	Summary:
            Returns True if selected object (xisState.selected_obj) matches this
        object type

        INPUTS:
            none
        
        OUTPUTS:
            none

        RETURNS:
            True = selected object matches specified object type
            False = no match
************************************************************************/


#include <AutoMessages.h>
#include "xislib.h"

int xisIsSelectedRegion(object_type_in)
int object_type_in;
{
    XisObjectRecord *object = xisFindObject(xisState.selected_widget,
                                            xisState.selected_object_type,
                                            xisState.selected_instance);

    int object_type, cum_object_type = object_type_in;
    int tmp;
    int succeed = 1;

    if (!xisInform.is_valid)
        AutoMessage(_AutoMessages[WARNMSG55]);

    if (object == NULL)
        return 0;

    while (object != NULL && cum_object_type > 0) {

        tmp = cum_object_type / xisNumObjectTypes;
        
        object_type = cum_object_type - (tmp*xisNumObjectTypes);
     
        if (object->id.object_type != object_type) {
            succeed = 0;
            break;
	}

        cum_object_type = tmp;

        object = object->parent;
    }

    return (object == xisInform.current_obj && succeed);

} /* End xisIsSelectedRegion() */
