/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: Form22.c /main/7 1995/07/13 17:39:35 drk $"
#endif
#endif
/*
 *  (c) Copyright 1987, 1988, 1989 HEWLETT-PACKARD COMPANY */

#include <testlib.h>
#define MAXTEXT 4

Widget Form;
Widget ScrolledList;
Widget PushButton1;
Widget PushButton2;

static void die();
static void RunTest();
static void CreateForm();
static void DestroyForm();

void  main(argc, argv)
int argc;
char **argv;
{
  register int  n;
  Arg args[MAX_ARGS];
  
  CommonTestInit(argc, argv);
    
  n = 0;
  XtSetArg (args[n], XmNwidth,  50);                               n++;
  XtSetArg (args[n], XmNheight, 25);                               n++;
  XtSetValues(Shell1, args, n);
    
  XtRealizeWidget(Shell1);    

  RunTest(Shell1);

  XtAppMainLoop(app_context);
}

static void RunTest(Shell)
Widget Shell;
{
  register int  i;
  register int  n;
  Arg args[MAX_ARGS];
  
  CreateForm(Shell);
  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_NONE);                 n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);              n++;
  XtSetValues(PushButton1, args, n);
  XtSetValues(PushButton2, args, n);
  CommonPause();

  DestroyForm();
  CreateForm(Shell);
  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_NONE);                 n++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);   		n++;
  XtSetValues(PushButton1, args, n);
  XtSetValues(PushButton2, args, n);
  CommonPause();

  DestroyForm();
}

static void CreateForm(Shell)
Widget Shell;
{
  register int  i;
  register int  n;
  Arg           args[MAX_ARGS];
  char          label[25];
  XmString      items[20];
  int           nitems = 20;

  for (i = 0; i < nitems; i++) {
    sprintf(label, "Item: %d", i);
    items[i] = XmStringCreate(label, XmSTRING_DEFAULT_CHARSET);
  }
  
  n = 0;
  XtSetArg(args[n], XmNautoUnmanage, False);                           n++;
  XtSetArg(args[n], XmNallowShellResize, True);                        n++;
  Form = XmCreateFormDialog(Shell, "Form", args, n);

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);                 n++;
  PushButton1 = XmCreatePushButton(Form, "PushButton1", args, n);

  n = 0;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);               n++;
  XtSetArg(args[n], XmNleftWidget, PushButton1);                       n++;
  XtSetArg(args[n], XmNitemCount, nitems);                             n++;
  XtSetArg(args[n], XmNitems, items);                                  n++;
  XtSetArg(args[n], XmNvisibleItemCount, 10);                          n++;
  ScrolledList = XmCreateScrolledList(Form, "ScrolledList", args, n);

  n = 0;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);                n++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);               n++;
  XtSetArg(args[n], XmNleftWidget, XtParent(ScrolledList));            n++;
  PushButton2 = XmCreatePushButton(Form, "PushButton2", args, n);

  XtManageChild(PushButton1);
  XtManageChild(PushButton2);
  XtManageChild(ScrolledList);
  XtManageChild(Form);
}

static void DestroyForm()
{
  XtDestroyWidget(Form);
}
