/* $XConsortium: MessageDia4.c /main/5 1995/07/15 21:07:05 drk $ */
/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 */
/* This test attempts to test CR 5895 which produces an X error on CONVEX
 * machines when a NULL pixmap is supplied to XtVaSetArgs XmNlabelPixmap.
 * It was never verified since it ran O.K. on Sparc/SunOS and 386/OSF/1.
 * The bug was reported against Motif 1.2.3.
 */

#include <stdio.h>

#include <testlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include "circles1.bmp"

XtAppContext    app_context;
Widget          toplevel;


XmString 
GetStatus( Pixmap p )
{
    static XmString validStr;
    static XmString unspecStr;
    static XmString nullStr;
    static int initialized = 0;

    if (initialized == 0) {
	validStr = XmStringLtoRCreate("The pixmap is a valid.", 
				      XmSTRING_DEFAULT_CHARSET);
	unspecStr = XmStringLtoRCreate("The pixmap is XmUNSPECIFIED_PIXMAP.", 
				       XmSTRING_DEFAULT_CHARSET);
	nullStr = XmStringLtoRCreate("The pixmap is NULL.", 
				     XmSTRING_DEFAULT_CHARSET);
	initialized = 1;
    }

    if (p == XmUNSPECIFIED_PIXMAP)
	return unspecStr;

    if (p == (Pixmap)NULL)
	return nullStr;

    return validStr;
}

main(int argc, char *argv[])
{
   Widget   form, testLabel, statusLabel;
   Pixmap   pixmap;
   Arg      args[10];
   int      n;

    /*  initialize toolkit  */
    CommonTestInit(argc, argv);
 
   /* create list of messages */
   form = XmCreateForm( Shell1, "form", NULL, 0);
   XtManageChild(form);

   n = 0;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNlabelType, XmPIXMAP); n++;
   testLabel = XmCreateLabel(form, "testLabel", args, n);
   XtManageChild(testLabel);

   n = 0;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(args[n], XmNtopWidget, testLabel); n++;
   XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
   statusLabel = XmCreateLabel(form, "statusLabel", args, n);
   XtManageChild(statusLabel);

   XtRealizeWidget(Shell1);

   /* CR 5895 */

   XtVaGetValues(testLabel, XmNlabelPixmap, &pixmap, NULL );

   /* This time around it should be UNSPECIFIED. */
   XtVaSetValues(statusLabel, XmNlabelString, GetStatus( pixmap ), NULL );
   
   CommonPause();

   XtVaSetValues(testLabel,
		 XmNlabelPixmap,
		   XCreatePixmapFromBitmapData(display,
					       DefaultRootWindow(display),
					       circles1_bits,
					       circles1_width, circles1_height,
					       WhitePixel(display,
						      DefaultScreen(display)),
					       BlackPixel(display,
						      DefaultScreen(display)),
					       DefaultDepth(display,
						      DefaultScreen(display))),
		 NULL);
   XtVaGetValues(testLabel, XmNlabelPixmap, &pixmap, NULL );

   /* This time around it should be "valid". */
   XtVaSetValues(statusLabel, XmNlabelString, GetStatus( pixmap ), NULL );
   
   CommonPause();

   XtVaSetValues(testLabel, XmNlabelPixmap, (Pixmap)NULL, NULL );
   XtVaGetValues(testLabel, XmNlabelPixmap, &pixmap, NULL );

   /* This time around it should be NULL. */
   XtVaSetValues(statusLabel, XmNlabelString, GetStatus( pixmap ), NULL );

   CommonPause();
   /* End CR 5895 */

   CommonPause(); /* Exit */

   XtAppMainLoop(app_context);
}
